var canvas = document.getElementById('myCanvas');
var ctx = canvas.getContext('2d');

var sound = document.getElementById('sound');

var menu = 0,
    speed = 3.0,
    virus = 0;
    virusSpeed = 1,
    keys = [],
    position = {
        playerX: 25.0,
        playerY: 150.0,
        virusX: 40.0,
        virusY: 24.0,
        virusArrayX: 2,
        virusArrayY: 1,
        yellowX: 0.0,
        yellowY: 0.0,
        dir: 0,
        virusDir: 0 
    }
var fNext = 10;

var walked = [];
    
//var   virusArrayPosX = Math.floor(position.virusX/16);
//var   virusArrayPosY = Math.floor(position.virusY/16);

var   openX = []
//var   openXOperator = (-,-,+,+,+,+,-,+);
var   openY = []
//var   openYOperator = (-,+,-,+,+,-,+,+);

var   scoreArray = [];
var   open = [];

var nowPlaying = 0;

//window.addEventListener("touchstart", StartJump, false);
//window.addEventListener("touchend", EndJump, false);

document.body.addEventListener("keydown", function (e) {
    keys[e.keyCode] = true;
});
document.body.addEventListener("keyup", function (e) {
    keys[e.keyCode] = false;
});

function endLevel() {
    document.getElementById('endAlert').style.visibility = 'visible';
    musicStop();
    menu = 1;
    //drawNewMap();
}

function drawNewMap() {
    document.getElementById('endAlert').style.visibility = 'hidden';
    menu = 0;
    lvl += 1;
    posX = 0.0;
    posY = 0.0;
    gems = 6;
    ctx.clearRect(0, 0, 320, 192);
    context.clearRect(0, 0, 320, 192);
    drawMap();
}

function Loop()
{
    Update();
    Render();
    window.setTimeout(Loop, 1000/60);    
}

function Update()
{
    var currentPos = {
        x:position.playerX,
        y:position.playerY,
    }
    if ( menu == 0 ) {
    drawVirus();
    //checkCollision('player');
    if (keys[87] || keys[38]) {
        position.dir = 'up'
        if (checkCollision() === true) {
            position.playerY = currentPos.y   
        }
        else {
            position.playerY -= speed;
        }
    }
    
    if (keys[65] || keys[37]) {
        position.dir = 'left'
        if (checkCollision() === true) {
            position.playerX = currentPos.x  
        }
        else {
            position.playerX -= speed;
        }
    }
    
    if (keys[68] || keys[39]) {
        position.dir = 'right'
        if (checkCollision() === true) {
            position.playerX = currentPos.x   
        }
        else {
            position.playerX += speed;
        }
    }
    
    if (keys[83] || keys[40]) {
        position.dir = 'down'
        if (checkCollision() === true) {
            position.playerY = currentPos.y   
        }
        else {
            position.playerY += speed;
        }
    }

    document.getElementById('locText').innerHTML = position.virusX + ', ' + position.virusY// +' | ' + currentPosY + ', ' + currentPosX + ', ' + mapArray[lvl][currentPosY][currentPosX] + ' | ' + gems //+ nextCharacterPosX + ', ' + nextCharacterPosY
    ctx.clearRect(0, 0, 320, 192);
    if ( gems == 3 ) {
        //fade();
    }
    if ( gems == 0 ) {
        endLevel();
    }
    }
    if ( menu == 1 ) {
    }
    
}

function Render()
{
    ctx.clearRect(0, 0, 320, 192);
    ctx.drawImage(sprite,32, 16, 16, 16, position.playerX-8, position.playerY-8, 16, 16);
    ctx.drawImage(sprite,48, 16, 16, 16, position.virusX-8, position.virusY-8, 16, 16);
    //ctx.drawImage(sprite,32, 16, 16, 16, position.yellowX-8, position.yellowY-8, 16, 16);
}

if ( nowPlaying == 0 ) {
    bgLightStart();
}
Loop();